/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class lui extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         lui.class,
         "lui",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, REG.INFO)
             .add("imm", SHORT),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new lui(rt, imm);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "lui",
          true,
          new ArgumentDecls()
              .add("rt", ArgumentMode.OUT, REG.INFO)
              .add("imm", SHORT),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new lui(
          rt,
          imm
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rt;
  public final Immediate imm;

  public lui(final REG rt, final Immediate imm) {
    assert REG.INFO.isSupported(rt);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.imm = imm;
  }

  @Override
  public String syntax() {
    return String.format("lui %s, 0x%x", rt.syntax(), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("001111%s%s", rt.image(), imm.access().load().toString());
  }

  @Override
  public void action() {
    rt.access().store(Data.signExtend(WORD, imm.access().load()).shiftLeft(Data.valueOf(WORD, 0x10)));
  }
}
