/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVE extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVE.class,
         "MOVE",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, R.INFO)
             .add("rs", ArgumentMode.IN, R.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);

      return new MOVE(rd, rs);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rs;

  public MOVE(final R rd, final R rs) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rs);
    this.rd = rd;
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("MOVE %s, %s", rd.syntax(), rs.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s00000%s00000100001", rd.image(), rs.image());
  }

  @Override
  public void action() {
    rd.access().store(rs.access().load());
  }
}
